<script lang="ts">
	import Button from '$lib/components/Button.svelte';
	import ComputerSection from '$lib/components/ComputerSection.svelte';
	import PlayerSection from '$lib/components/PlayerSection.svelte';
	import type { Choice, Result } from '$lib/domains/RPS.type';
	import { spring } from 'svelte/motion';
  import { fade } from 'svelte/transition';

  export let opponentName: string = "Computer";

	let playerChoice: Choice = null;
	let opponentChoice: Choice = null;
	let result: Result = null;
	let playerScore = 0;
	let opponentScore = 0;
	let userWaiting = false;

  const displayedPlayerScore = spring();
  const displayedOpponentScore = spring();
  $: displayedPlayerScore.set(playerScore);
  $: displayedOpponentScore.set(opponentScore);
  $: offsetPlayer = $displayedPlayerScore % 1;
  $: offsetOpponent = $displayedOpponentScore % 1;

	const choices: Choice[] = ['rock', 'paper', 'scissors'];

	function getResult() {
		if (!playerChoice || !opponentChoice) return null;
		if (playerChoice === opponentChoice) {
			return 'draw';
		} else if (
			(playerChoice === 'rock' && opponentChoice === 'scissors') ||
			(playerChoice === 'paper' && opponentChoice === 'rock') ||
			(playerChoice === 'scissors' && opponentChoice === 'paper')
		) {
			return 'win';
		} else {
			return 'lose';
		}
	}

	function handleContinue() {
		playerChoice = null;
		opponentChoice = null;
		result = null;
		userWaiting = false;
	}

	function handleReset() {
		playerChoice = null;
		opponentChoice = null;
		result = null;
		playerScore = 0;
		opponentScore = 0;
		userWaiting = false;
	}

	$: if (playerChoice) {
		opponentChoice = choices[Math.floor(Math.random() * choices.length)];
	}

	$: if (playerChoice && opponentChoice) {
		userWaiting = true;
		result = getResult();
		if (result === 'win') {
			playerScore++;
		} else if (result === 'lose') {
			opponentScore++;
		}
	}
</script>

<section class="container">
	<div class="score">
		<p>Score</p>
		<div class="score-flex">
      <div class="counter-viewport">
        <div class="counter-digits color-opponent" style="transform: translate(0, {100 * offsetOpponent}%)">
          <span class="hidden" aria-hidden="true">
            {Math.floor($displayedOpponentScore + 1)}
          </span>
          <span>
            {Math.floor($displayedOpponentScore)}
          </span>
        </div>
      </div>
			-
      <div class="counter-viewport">
        <div class="counter-digits color-player" style="transform: translate(0, {100 * offsetPlayer}%)">
          <span class="hidden" aria-hidden="true">
            {Math.floor($displayedPlayerScore + 1)}
          </span>
          <span>
            {Math.floor($displayedPlayerScore)}
          </span>
        </div>
      </div>
		</div>
	</div>
	<section class={`opponent-choice ${result ? result : ""}`}>
    <h2 class="color-opponent">{opponentName}</h2>
		<ComputerSection bind:computerChoice={opponentChoice} />
  </section>
	<div class="separator">
		<span class={`result ${result}`}>{result ? result : 'VS'}</span>
	</div>
	<section class={`player-choice ${result ? result : ""}`}>
    <h2 class="color-player">You</h2>
		<PlayerSection bind:playerChoice {userWaiting} />
	</section>
	{#if userWaiting}
		<div transition:fade={{duration: 200}} class="button-container">
			<Button variant="outlined" on:click={handleReset}>Reset</Button>
			<Button on:click={handleContinue}>Continue</Button>
		</div>
	{/if}
</section>

<style>
	section.container {
		--color-player: #48dbfb;
		--color-opponent: #ff6b6b;

		flex: 1;
		display: flex;
		flex-direction: column;
		gap: 4rem;
	}

	.score {
		display: flex;
		flex-direction: column;
		font-size: 1.5rem;
		align-items: center;
	}
	.score p {
		font-size: 1.7rem;
		font-weight: bold;
	}

  .score-flex {
    display: flex;
    align-items: center;
    justify-content: center;
    gap: 1rem;
  }
	.color-player {
		color: var(--color-player);
	}
	.color-opponent {
		color: var(--color-opponent);
	}

  section h2 {
    text-align: center;
    margin-bottom: 0.5rem;
  }

	.separator {
		position: relative;
		background: var(--color-text);
		height: 1px;
	}
	.separator .result {
		z-index: 1;
		position: absolute;
		top: 50%;
		left: 50%;
		transform: translateX(-50%) translateY(-50%);

		display: flex;
		align-items: center;
		justify-content: center;
		width: 4rem;

		background: var(--color-text);
		padding: 0.3rem 0.5rem;
		font-size: 1.2rem;
		border-radius: 10rem;
		color: var(--color-bg-1);
	}
  .separator .result.win {
    background: var(--color-player);
    color: var(--color-bg-1);
  }
  .separator .result.lose {
    background: var(--color-opponent);
    color: var(--color-bg-1);
  }

  .button-container {
    display: flex;
    justify-content: center;
    gap: 1rem;
  }

  .counter-viewport {
		width: 2em;
		height: 2em;
		overflow: hidden;
		text-align: center;
		position: relative;
	}

	.counter-viewport span {
		position: absolute;
		display: flex;
		width: 100%;
		height: 100%;
		font-weight: 400;
		font-size: 1.5rem;
		align-items: center;
		justify-content: center;
	}

	.counter-digits {
		position: absolute;
		width: 100%;
		height: 100%;
	}

	.hidden {
		top: -100%;
		user-select: none;
	}

  .player-choice.lose, .opponent-choice.win {
    animation: shake 0.2s ease-in-out;
  }
  .player-choice.win, .opponent-choice.lose {
    animation: grow 0.5s ease-in-out;
  }

  @keyframes shake {
    0% {
      transform: translateX(-10px);
    }
    50% {
      transform: translateX(10px);
    }
    100% {
      transform: translateX(-10px);
    }
  }
  @keyframes grow {
    0% {
      transform: scale(1);
    }
    50% {
      transform: scale(1.05);
    }
    100% {
      transform: scale(1);
    }
  }
</style>
